p = lxp_make_parser()

function p:starttag(name, attr)
  print("start",name)
  for i,v in attr do
    print("attribute", i, v);
  end
end

function p:endtag(name)
  print("end", name)
end

function p:chardata(s)
  print("chardata", s)
end

if arg then filename = arg[1] end
if not filename then filename = "foo.xml" end

function error_report(p)
  print("expat parse error ", lxp_error_code(p), "error string", lxp_error_string(p))
  print("at line", lxp_get_line_number(p), "column", lxp_get_column_number(p))
  exit(1)
end

readfrom(filename)
while 1 do
  line = read()
  if not line then break end
  print("------------------")
  print("line:", line)
  if not lxp_parse(p, line.."\n") then 
    error_report(p)
  end
end
readfrom()

if not lxp_parse_end(p) then 
error_report(p)
end
